Project Chrono: chrono::ChShaftsMotorPosition Class Reference

Public Member Functions | List of all members
chrono::ChShaftsMotorPosition Class Reference

## Description

Motor to enforce the relative position r(t) between two shafts, using a rheonomic constraint.

The position of shaft A with respect to shaft B is set trhough a function of time f(t) and an optional offset: r(t) = f(t) + offset The relative position represents an angle for rotational motor and a displacement for linear motors. Note: no compliance is allowed, so if the actuator hits an undeformable obstacle it hits a pathological situation and the solver result can be unstable/unpredictable. Think at it as a servo drive with "infinitely stiff" control. This type of motor is very easy to use, stable and efficient and should be used if the 'infinitely stiff' control assumption is a good approximation of what you simulate (e.g., very good and reactive controllers). By default it is initialized with linear ramp: df/dt = 1. Use SetPositionFunction() to change to other motion functions.

`#include <ChShaftsMotorPosition.h>`

Inheritance diagram for chrono::ChShaftsMotorPosition:
[legend]
Collaboration diagram for chrono::ChShaftsMotorPosition:
[legend]

## Public Member Functions
| ChShaftsMotorPosition (const ChShaftsMotorPosition &other)
virtual ChShaftsMotorPosition * | Clone () const override
| "Virtual" copy constructor (covariant return type).
void | SetPositionFunction (const std::shared_ptr< ChFunction > function)
| Set the motor function, f(t).
std::shared_ptr< ChFunction > | GetPositionFunction () const
| Gets the motor function f(t).
void | SetOffset (double offset)
| Set the initial offset for f(t)=0 (default: 0).
double | GetOffset () const
| Get the initial offset for f(t) = 0.
bool | Initialize (std::shared_ptr< ChShaft > shaft_1, std::shared_ptr< ChShaft > shaft_2) override
| Initialize the motor, given two shafts to join.
virtual double | GetMotorLoad () const override
| Get the current motor load between shaft2 and shaft1, expressed as applied to shaft1.
double | GetConstraintViolation () const
| Return current constraint violation.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChShaftsMotor
| ChShaftsMotor (const ChShaftsMotor &other)
virtual double | GetMotorPos () const
| Get the position of the motor, as position of shaft 1 with respect to 2.
virtual double | GetMotorPosDt () const
| Get the motor speed, as speed of shaft 1 with respect to 2.
virtual double | GetMotorPosDt2 () const
| Get the motor acceleration, as accelerations of shaft 1 with respect to 2.
virtual int | GetMotorNumTurns () const
| Get number of full rotations for this shafts rotational motor.
virtual double | GetMotorAngleWrapped () const
| Get the motor angle in the range [-pi, +pi].
virtual double | GetReaction1 () const override
| Get the reaction torque exchanged between the two shafts, considered as applied to the 1st axis.
virtual double | GetReaction2 () const override
| Get the reaction torque exchanged between the two shafts, considered as applied to the 2nd axis.
Public Member Functions inherited from chrono::ChShaftsCouple
| ChShaftsCouple (const ChShaftsCouple &other)
virtual unsigned int | GetNumAffectedCoords ()
| Get the number of scalar variables affected by constraints in this couple.
ChShaft * | GetShaft1 () const
| Get the first (input) shaft.
ChShaft * | GetShaft2 () const
| Get the second (output) shaft.
double | GetRelativePos () const
| Get the actual relative position (angle or displacement) in terms of phase of shaft 1 with respect to 2.
double | GetRelativePosDt () const
| Get the actual relative speed (angle or displacement) of shaft 1 with respect to 2.
double | GetRelativePosDt2 () const
| Get the actual relative acceleration (angle or displacement) of shaft 1 with respect to 2.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsActive () const
| Return true if the object is active and included in dynamics.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | Update (bool update_assets=true)
| As above, but does not require updating of time-dependent data.
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsPosLevel ()
| Get the number of coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c)
| Takes the F force term, scale and adds to R at given offset: R += c*F.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1)
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1)
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()
Protected Attributes inherited from chrono::ChShaftsCouple
ChShaft * | shaft1
| first shaft
ChShaft * | shaft2
| second shaft
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChShaftsMotorPosition::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Method to allow de serialization of transient data from archives.

Reimplemented from chrono::ChShaftsMotor.

## ◆ ArchiveOut()

void chrono::ChShaftsMotorPosition::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChShaftsMotor.

## ◆ Clone()

virtual ChShaftsMotorPosition * chrono::ChShaftsMotorPosition::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChShaftsCouple.

## ◆ GetMotorLoad()

virtual double chrono::ChShaftsMotorPosition::GetMotorLoad | ( |  | ) | const
| inlineoverridevirtual

Get the current motor load between shaft2 and shaft1, expressed as applied to shaft1.

Implements chrono::ChShaftsMotor.

## ◆ Initialize()

bool chrono::ChShaftsMotorPosition::Initialize | ( | std::shared_ptr< ChShaft > | shaft_1,
|  | std::shared_ptr< ChShaft > | shaft_2 )
| overridevirtual

Initialize the motor, given two shafts to join.

The first shaft is the 'output' shaft of the motor, the second is the 'truss', often fixed and not moving. The load is applied to the output shaft, while the truss shafts gets the same load but with opposite sign. Both shafts must belong to the same ChSystem.

Parameters

  shaft_1 | first shaft to join (motor output shaft)
  shaft_2 | second shaft to join (motor truss)

Reimplemented from chrono::ChShaftsCouple.

## ◆ SetOffset()

void chrono::ChShaftsMotorPosition::SetOffset | ( | double | offset | ) |
| inline

Set the initial offset for f(t)=0 (default: 0).

Relative position of the two shafts will be r(t) = f(t) + offset.

## ◆ SetPositionFunction()

void chrono::ChShaftsMotorPosition::SetPositionFunction | ( | const std::shared_ptr< ChFunction > | function | ) |
| inline

Set the motor function, f(t).

This function outputs an angle for a rotational motor and a displacement for a linear motor. Note that is must be at least C0 continuous. Ideally, f is C1, otherwise it produces spikes in accelerations.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsMotorPosition.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsMotorPosition.cpp